#!/usr/bin/python
#
'''Make shinGETsu Live Link.

1. Run command:
    mksuggest > suggest.js
2. Write tags in HTML files:
    <p><a href="http://example.com/" id="shingetsu_link">foo</a></p>
    <script type="text/javascript" src="http://example.com/suggest.js" charset="utf-8"></script>
'''
#
# Copyright (c) 2006 shinGETsu Project.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: mksuggest.py 1261 2006-09-06 11:48:04Z fuktommy $
#

import os
import sys
import cgi
import socket
import urllib

import config

socket.setdefaulttimeout(10)

server = config.server_name
port = config.port
docroot = config.apache_docroot

def get_titles():
    f = urllib.urlopen('http://localhost:%d/gateway.cgi/csv/changes/title' %
                       port)
    titles = []
    for line in f:
        titles.append(line.strip())
    return titles

def print_jsfile(titles, fp):
    fp.write(
        '(function () {\n' +
        '    var titles = [\n')
    for i in titles[:-1]:
        fp.write('"%s",\n' % cgi.escape(i, True))
    fp.write('"%s"' % cgi.escape(titles[-1], True))

    fp.write('''
    ];

    var node = 'http://%s/thread.cgi/';
    var link;
    ''' % server)

    fp.write('''
    function similarity(data, title) {
        var point = 0;
        for (var n=1; n<=title.length; n++) {
            for (var i=0; i<=title.length-n; i++) {
	        var key = title.substr(i, n);
	        if (data.indexOf(key) >= 0) {
	            point += n;
	        }
            }
        }
        return point
    }

    function selectTitle() {
        var data = document.getElementsByTagName('body')[0].innerHTML;
        data = data.replace(/<!--.*?-->/g, '');
        data = data.replace(/<!\[CDATA\[.*?\]\]>/g, '');
        data = data.replace(/<.*?>/g, '');
        var title = titles[0];
        var point = similarity(data, title);
        for (var i=1; i<titles.length; i++) {
            var tmp =  similarity(data, titles[i]);
            if (point < tmp) {
                title = titles[i];
                point = tmp;
            }
        }
        return title;
    }

    function main() {
        link = document.getElementById('shingetsu_link');
        if (link) {
            var title = selectTitle();
            link.innerHTML = title;
            link.href = node + encodeURIComponent(title);
        }
    }

    main();
})();
''')

def main():
    titles = get_titles()
    print_jsfile(titles, sys.stdout)

if __name__ == '__main__':
    main()
